<?php

/**
* @Copyright Copyright (C) 2010 www.profinvent.com. All rights reserved.
* Copyright (C) 2014 Open Source Group GmbH www.osg-gmbh.de
* @website http://www.profinvent.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 2 of the License, or
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class SeminarmanModelDay extends JModelLegacy
{
    var $_id = null;
    
    var $_db = null;
    
    var $_date = null;

    var $_data = null;

    var $_childs = null;

    var $_total = null;
    
    var $_ccid = null;
    
    var $_bookings = null; // holds the course id of all applications of the current user

    function __construct()
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();
		$_db = JFactory::getDBO();

        $params = $mainframe->getParams('com_seminarman');
        
        $orderingDef = $params->get('list_ordering');
        switch ($orderingDef)
        {
        	case '0' :
        		$ordering = 'i.title';
        		break;
        
        	case '1' :
        		$ordering = 'i.start_date';
        		break;
        
        	case '2' :
        		$ordering = 'i.ordering';
        		break;
        }

        $id = JRequest::getInt('did', date('Ymd'));
        $this->setId((int) $id);

        $l = JRequest::getString('ccid');
        if(!empty($l))
        	$this->setLimit($l);
        	
        $limit = $mainframe->getUserStateFromRequest('com_seminarman.day.limit', 'limit', $params->def('limit', 0), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
        
        $tmpl_limit = $mainframe->getUserStateFromRequest('com_seminarman.day.tmpl_limit', 'tmpl_limit', $mainframe->getCfg('list_limit'), 'int');
        $tmpl_limitstart = JRequest::getVar('tmpl_limitstart', 0, '', 'int');
        $tmpl_limitstart = ($tmpl_limit != 0 ? (floor($tmpl_limitstart / $tmpl_limit) * $tmpl_limit) : 0);
        
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
        $this->setState('tmpl_limit', $tmpl_limit);
        $this->setState('tmpl_limitstart', $tmpl_limitstart);
        
        $this->setState('filter_order', JRequest::getCmd('filter_order', $ordering));
        $this->setState('filter_order_dir', JRequest::getCmd('filter_order_Dir', 'ASC'));
        $this->setState('filter_order2', JRequest::getCmd('filter_order2', $ordering));
        $this->setState('filter_order_dir2', JRequest::getCmd('filter_order_Dir2', 'ASC'));
    }

    function setId($id)
    {
        $this->_id = $id;
        $this->_date = date('Y-m-d', strtotime(substr($id, 0, 4) . '/' . substr($id, 4, 2) . '/' . substr($id, 6, 2)));
    }

    function setLimit($limit)
    {
        $this->_ccid = explode(':', $limit);
    }

    function getId()
    {
        return $this->_id;
    }

    function getDay()
    {
    	$date = new JDate($this->_date);
        return $date->format(JText::_('DATE_FORMAT_LC'));
    }

    function getData()
    {
    	
        if (empty($this->_data))
        {
            $query = $this->_buildQuery();
            $this->_db->setQuery($query, $this->getState('limitstart'), $this->getState('limit'));
            $this->_data = $this->_db->loadObjectList();
        }

        return $this->_data;
    }

    function getTotal()
    {

        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_db->setQuery($query);
            $this->_total = count($this->_db->loadObjectList());
        }

        return $this->_total;
    }

    function _buildQuery()
    {

        $where = $this->_buildCourseWhere();
        $orderby = $this->_buildCourseOrderBy();

		$query = $this->_db->getQuery(true);
				$query->select('DISTINCT i.*, (i.plus / (i.plus + i.minus) ) * 100 AS votes,' .
				' CONCAT_WS(" ", emp.firstname, emp.lastname) as tutor,' .        
				' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,' .
				' gr.title AS cgroup, lev.title AS level');
				$query->from('#__seminarman_courses AS i');
				$query->leftJoin('#__seminarman_cats_course_relations AS rel ON rel.courseid = i.id');
				$query->leftJoin('#__seminarman_tutor AS emp ON emp.id = i.tutor_id');
				$query->leftJoin('#__seminarman_atgroup AS gr ON gr.id = i.id_group');
				$query->leftJoin('#__seminarman_experience_level AS lev ON lev.id = i.id_experience_level');
				$query->leftJoin('#__seminarman_categories AS c ON c.id = rel.catid');
				$query->where($where);
				$query->order($orderby);
		
//        $query = 'SELECT DISTINCT i.*, (i.plus / (i.plus + i.minus) ) * 100 AS votes,' .
//            ' CONCAT_WS(" ", emp.firstname, emp.lastname) as tutor,' .        
//            ' CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(\':\', i.id, i.alias) ELSE i.id END as slug,' .
//            ' gr.title AS cgroup, lev.title AS level' .
//            ' FROM #__seminarman_courses AS i' .
//            ' LEFT JOIN #__seminarman_cats_course_relations AS rel ON rel.courseid = i.id' .
//            ' LEFT JOIN #__seminarman_tutor AS emp ON emp.id = i.tutor_id' .
//            ' LEFT JOIN #__seminarman_atgroup AS gr ON gr.id = i.id_group' .
//            ' LEFT JOIN #__seminarman_experience_level AS lev ON lev.id = i.id_experience_level' .
//            ' LEFT JOIN #__seminarman_categories AS c ON c.id = rel.catid' . $where . $orderby;


        return $query;
    }

    function _buildCourseOrderBy()
    {
        $filter_order = $this->getState('filter_order');
        $filter_order_dir = $this->getState('filter_order_dir');

        return $filter_order .' '. $filter_order_dir .', i.title';
    }

    function _buildCourseWhere()
    {
        $mainframe = JFactory::getApplication();

        $user = JFactory::getUser();
        $gid = (int)$user->get('aid');

        $jnow = JFactory::getDate();
        // $now = $jnow->toMySQL();
        $now = $jnow->toSQL();
        $nullDate = $this->_db->getNullDate();

        $state = 1;

        $params = $mainframe->getParams('com_seminarman');
        
        $where = 'i.start_date <= \'' . $this->_date . '\' AND i.finish_date >= \'' . $this->_date . '\'';

        switch ($state)
        {
            case 1:

                $where .= ' AND i.state = 1' . ' AND ( publish_up = ' . $this->_db->Quote($nullDate) .
                    ' OR publish_up <= ' . $this->_db->Quote($now) . ' )' . ' AND ( publish_down = ' .
                    $this->_db->Quote($nullDate) . ' OR publish_down >= ' . $this->_db->Quote($now) .
                    ' )';

                break;

            case - 1:

                $year = JRequest::getInt('year', date('Y'));
                $month = JRequest::getInt('month', date('m'));

                $where .= ' AND i.state = -1';
                $where .= ' AND YEAR( i.created ) = ' . (int)$year;
                $where .= ' AND MONTH( i.created ) = ' . (int)$month;
                break;

            default:
                $where .= ' AND i.state = ' . (int)$state;
                break;
        }


        if ($params->get('filter'))
        {

            $filter = JRequest::getString('filter', '', 'request');
            $filter_experience_level = JRequest::getString('filter_experience_level', '', 'request');
            $filter_positiontype = JRequest::getString('filter_positiontype', '', 'request');

            if ($filter)
            {

                $filter = $this->_db->escape(trim(JString::strtolower($filter)));
                $like = $this->_db->Quote('%'. $this->_db->escape($filter, true) .'%', false);

                $where .= ' AND ( LOWER( i.title ) LIKE ' . $like .' OR LOWER( i.code ) LIKE '. $like .')';
            }
        } else {
            $filter_experience_level = null;
        }

        if ($filter_experience_level>0)
        {
            $where .= ' AND LOWER( i.id_experience_level ) = ' . $filter_experience_level;
        }
        
        if (isset($this->_ccid) && count($this->_ccid) > 0)
        {
            $where .= ' AND i.id IN (' . implode(',', $this->_ccid) . ')';
        }

        return $where;
    }

    function getTitles()
    {
        $user = JFactory::getUser();
        $gid = (int)$user->get('aid');

        $query = 'SELECT id, title' . ' FROM #__seminarman_experience_level' .
            ' WHERE published = 1' . ' ORDER BY ordering ASC';

        $this->_db->setQuery($query);
        $this->_subs = $this->_db->loadObjectList();

        return $this->_subs;
    }
    
    function hasUserBooked($course_id)
    {
    	if (empty($this->_bookings))
    		$this->_loadBookings();
    	
    	return in_array($course_id, $this->_bookings);
    }
    
	function _loadBookings()
	{
		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		
		$q = 'SELECT course_id FROM `#__seminarman_application`'.
        	          ' WHERE user_id = '. $user->id. 
        	          ' AND published = 1 AND status < 3';
		$db->setQuery($q);
		// $this->_bookings = $db->loadResultArray();
		$this->_bookings = $db->loadColumn();
	}
	
}

?>